<template>
  <q-card class="q-mt-sm">
    <q-card-section>
      <div class="row q-col-gutter-md">
        <div class="col-6">
          <q-input
            v-model="formData.titulo"
            label="titulo"
            dense
            filled
            :error="validacion.has('titulo')"
            :error-message="validacion.first('titulo')"
          >
            <template v-slot:prepend>
              <q-icon name="maps_home_work" />
            </template>
          </q-input>
          <q-select
            v-model="formData.tipo"
            dense
            filled
            emit-value
            stack-label
            map-options
            :options="[
              { label: 'Informacion', value: 'blue' },
              { label: 'Correcto', value: 'green' },
              { label: 'Alerta', value: 'orange' },
              { label: 'Error', value: 'red' },
            ]"
            label="Tipo: "
          />
        </div>

        <div class="col-6">
          <q-input
            v-model="formData.f_inicio"
            type="date"
            filled
            dense
            label="Fecha Inicio"
            :error="validacion.has('f_inicio')"
            :error-message="validacion.first('f_inicio')"
          >
            <template v-slot:prepend>
              <q-icon name="maps_home_work" />
            </template>
          </q-input>

          <q-input
            v-model="formData.f_fin"
            type="date"
            filled
            dense
            label="Fecha Fin"
            :error="validacion.has('f_fin')"
            :error-message="validacion.first('f_fin')"
          >
            <template v-slot:prepend>
              <q-icon name="signpost" />
            </template>
          </q-input>
        </div>

        <div class="col-12">
          <q-input
            v-model="formData.detalle"
            label="detalle"
            filled
            :error="validacion.has('detalle')"
            :error-message="validacion.first('detalle')"
            type="textarea"
          >
            <template v-slot:prepend>
              <q-icon name="question_answer" />
            </template>
          </q-input>
          <q-input
            v-model="formData.link"
            label="link"
            dense
            filled
            :error="validacion.has('link')"
            :error-message="validacion.first('link')"
          >
            <template v-slot:prepend>
              <q-icon name="signpost" />
            </template>
          </q-input>
        </div>
      </div>

      <div class="row q-col-gutter-xs q-mt-sm">
        <div class="col-12">
          <q-btn
            v-if="formData.uuid"
            @click="submitUpdate"
            class="full-width"
            color="green"
          >
            Actualizar novedad
          </q-btn>
          <q-btn
            v-if="!formData.uuid"
            @click="submitCrear"
            class="full-width"
            color="green"
          >
            Crear novedad
          </q-btn>
        </div>
      </div>

      <Loading :showing="loading" :text="loading_text" />
    </q-card-section>
  </q-card>
</template>

<script lang="ts">
import { defineComponent, ref, onMounted } from 'vue';
import { api, validacion } from 'src/boot/axios/index';
import { AxiosResponse } from 'axios';
import { useRoute, useRouter } from 'vue-router';
import { LugaresInterface } from 'src/interfaces/EventosInterface';
import Loading from 'src/components/Loading.vue';

export default defineComponent({
  name: 'EventosLugarFormularioPage',
  components: { Loading },
  setup() {
    // const router = useRouter();
    const router = useRouter();
    const route = useRoute();
    const uuid = String(
      route.params.uuid === undefined ? '' : route.params.uuid
    );

    const loading = ref(false);
    const loading_text = ref<string>('Obteniendo Datos');

    const formData = ref({
      nombre: null,
      direccion: null,
      localidad: null,
      telefono: null,
      comentario: null,
      maps: null,
    });

    onMounted(() => {
      if (uuid != '') {
        // si paso un uuid, primero tengo que obtener el evento, para saber que tipo de area es
        getDatos();
      }
    });

    function getDatos() {
      loading.value = true;
      api
        .get<LugaresInterface>('/api/administrador/novedades/' + uuid)
        .then((response: AxiosResponse) => {
          formData.value = response.data;
        })
        .finally(() => {
          loading.value = false;
        });
    }

    function submitCrear() {
      loading_text.value = 'Enviando Datos';
      loading.value = true;
      api
        .post('/api/administrador/novedades', formData.value)
        .then(() => {
          router.push({ path: '/administrador/novedades' });
        })
        .finally(() => {
          loading.value = false;
        });
    }

    function submitUpdate() {
      loading_text.value = 'Enviando Datos';

      loading.value = true;
      api
        .put('/api/administrador/novedades', formData.value)
        .then(() => {
          router.push({ path: '/administrador/novedades' });
        })
        .finally(() => {
          loading.value = false;
        });
    }

    return {
      validacion,
      loading,
      loading_text,
      formData,
      submitCrear,
      submitUpdate,
    };
  },
});
</script>
